<?php

declare(strict_types=1);

namespace App\Repository;

final class TblPreguntasXUsuarioRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblPreguntasXUsuarioId): object
    {
        $query = 'SELECT * FROM `TblPreguntasXUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPreguntasXUsuarioId);
        $statement->execute();
        $TblPreguntasXUsuario = $statement->fetchObject();
        if (! $TblPreguntasXUsuario) {
            throw new \Exception('TblPreguntasXUsuario not found.', 404);
        }

        return $TblPreguntasXUsuario;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblPreguntasXUsuario` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblPreguntasXUsuario): object
    {
        $query = 'INSERT INTO `TblPreguntasXUsuario` (`IdModulo`, `IdPregunta`, `IdTema`, `IdRespuesta`, `Estado`, `IdEstado`, `IdUsuario`, `field1`, `field2`, `field3`, `field4`, `field5`) 
        VALUES (:IdModulo, :IdPregunta, :IdTema, :IdRespuesta, :Estado, :IdEstado, :IdUsuario, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblPreguntasXUsuario->id);
//         $statement->bindParam('fecha', $TblPreguntasXUsuario->fecha);
        $statement->bindParam('IdModulo', $TblPreguntasXUsuario->IdModulo);
        $statement->bindParam('IdPregunta', $TblPreguntasXUsuario->IdPregunta);
        $statement->bindParam('IdTema', $TblPreguntasXUsuario->IdTema);
        $statement->bindParam('IdRespuesta', $TblPreguntasXUsuario->IdRespuesta);
        $statement->bindParam('Estado', $TblPreguntasXUsuario->Estado);
//         $statement->bindParam('FechaRespuesta', $TblPreguntasXUsuario->FechaRespuesta);
        $statement->bindParam('IdEstado', $TblPreguntasXUsuario->IdEstado);
        $statement->bindParam('IdUsuario', $TblPreguntasXUsuario->IdUsuario);
        $statement->bindParam('field1', $TblPreguntasXUsuario->field1);
        $statement->bindParam('field2', $TblPreguntasXUsuario->field2);
        $statement->bindParam('field3', $TblPreguntasXUsuario->field3);
        $statement->bindParam('field4', $TblPreguntasXUsuario->field4);
        $statement->bindParam('field5', $TblPreguntasXUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblPreguntasXUsuario, object $data): object
    {
        if (isset($data->fecha)) {
            $TblPreguntasXUsuario->fecha = $data->fecha;
        }
        if (isset($data->IdModulo)) {
            $TblPreguntasXUsuario->IdModulo = $data->IdModulo;
        }
        if (isset($data->IdPregunta)) {
            $TblPreguntasXUsuario->IdPregunta = $data->IdPregunta;
        }
        if (isset($data->IdTema)) {
            $TblPreguntasXUsuario->IdTema = $data->IdTema;
        }
        if (isset($data->IdRespuesta)) {
            $TblPreguntasXUsuario->IdRespuesta = $data->IdRespuesta;
        }
        if (isset($data->Estado)) {
            $TblPreguntasXUsuario->Estado = $data->Estado;
        }
        if (isset($data->FechaRespuesta)) {
            $TblPreguntasXUsuario->FechaRespuesta = $data->FechaRespuesta;
        }
        if (isset($data->IdEstado)) {
            $TblPreguntasXUsuario->IdEstado = $data->IdEstado;
        }
        if (isset($data->IdUsuario)) {
            $TblPreguntasXUsuario->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->field1)) {
            $TblPreguntasXUsuario->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblPreguntasXUsuario->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblPreguntasXUsuario->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblPreguntasXUsuario->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblPreguntasXUsuario->field5 = $data->field5;
        }

        $query = 'UPDATE `TblPreguntasXUsuario` SET `fecha` = :fecha, `IdModulo` = :IdModulo, `IdPregunta` = :IdPregunta, `IdTema` = :IdTema, `IdRespuesta` = :IdRespuesta, `Estado` = :Estado, `FechaRespuesta` = :FechaRespuesta, `IdEstado` = :IdEstado, `IdUsuario` = :IdUsuario, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPreguntasXUsuario->id);
        $statement->bindParam('fecha', $TblPreguntasXUsuario->fecha);
        $statement->bindParam('IdModulo', $TblPreguntasXUsuario->IdModulo);
        $statement->bindParam('IdPregunta', $TblPreguntasXUsuario->IdPregunta);
        $statement->bindParam('IdTema', $TblPreguntasXUsuario->IdTema);
        $statement->bindParam('IdRespuesta', $TblPreguntasXUsuario->IdRespuesta);
        $statement->bindParam('Estado', $TblPreguntasXUsuario->Estado);
        $statement->bindParam('FechaRespuesta', $TblPreguntasXUsuario->FechaRespuesta);
        $statement->bindParam('IdEstado', $TblPreguntasXUsuario->IdEstado);
        $statement->bindParam('IdUsuario', $TblPreguntasXUsuario->IdUsuario);
        $statement->bindParam('field1', $TblPreguntasXUsuario->field1);
        $statement->bindParam('field2', $TblPreguntasXUsuario->field2);
        $statement->bindParam('field3', $TblPreguntasXUsuario->field3);
        $statement->bindParam('field4', $TblPreguntasXUsuario->field4);
        $statement->bindParam('field5', $TblPreguntasXUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblPreguntasXUsuario->id);
    }

    public function delete(int $TblPreguntasXUsuarioId): void
    {
        $query = 'DELETE FROM `TblPreguntasXUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblPreguntasXUsuarioId);
        $statement->execute();
    }
}
